﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;

namespace Unicode_Probs
{
    class Program
    {
        static void Main(string[] args)
        {
            pubsEntities context = new pubsEntities();

            var v1 = from a in context.authors
                     where a.au_fname == "Ann"
                     select a;

            var v1a = v1.ToList();

            var v2 = from a in context.authors
                     where a.au_fname != "Ann"
                     select a;

            var v2a = v2.ToList();

            var v3 = from a in context.authors
                     where a.au_fname == "Ann" && a.au_lname == "Dull"
                     select a;

            var v3a = v3.ToList();

            var v4 = from a in context.authors
                     where a.au_fname == "Ann" || a.au_lname == "Dull"
                     select a;

            var v4a = v4.ToList();

            var nameList = new List<string>() { "Smith", "Johnson" };
            var v5 = from p in context.authors
            where nameList.Contains(p.au_lname)
            select p.au_id;

            var v5a = v5.ToList();

            // fix with AsNonUnicode
            var v6 = from a in context.authors
                     where a.au_fname != EntityFunctions.AsNonUnicode("Ann")
                     select a;

            var v6a = v6.ToList();

            // doesn't work with list of strings
            var nameList7 = new List<string>() { EntityFunctions.AsNonUnicode("Smith"), EntityFunctions.AsNonUnicode("Johnson") };
            var v7 = from p in context.authors
                     where nameList7.Contains(p.au_lname)
                     select p.au_id;

            var v7a = v7.ToList();
        }
    }
}
